/*
 * ESCAPE key!
 * 
 * For Arduino Leonardo
 * 
 * Pin 9 - Active low button (external pull-up for longer runs to button)
 * Pin 13 - LED output
 * 
 */
#include <Keyboard.h>

boolean prevBut = false;
boolean curBut = false;
boolean buttonDown = false;

void setup() {
  pinMode(9, INPUT);
  pinMode(13, OUTPUT);
}

void loop() {
  delay(20);    // Debounce period in mSec
  
  curBut = digitalRead(9) == LOW;
  if (curBut && prevBut && !buttonDown) {
    // Send ESC character (only enable HID briefly)
    Keyboard.begin();
    Keyboard.press(KEY_ESC);
    Keyboard.release(KEY_ESC);
    Keyboard.end();
  }
  buttonDown = curBut && prevBut;
  prevBut = curBut;

  // LED
  if (buttonDown) {
    digitalWrite(13, HIGH);
  } else {
    digitalWrite(13, LOW);
  }
}
